;Metro_Phase.csd

<CsoundSynthesizer>
<CsOptions>
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384   
</CsOptions>
<CsInstruments>

sr     =        44100
kr     =        100
ksmps  =        441
nchnls =        2
0dbfs = 1

;global var as percent
giaug init 1.3
gidim init 0.7

;wave for buzz
gisine  ftgen 2, 0, 512, 5, 1, 512, 2 ;steep sine

;global arrays
gipch[] fillarray 7.03, 8.03
gidurs[] fillarray (.5 * giaug), (.5 * gidim)

i1 lenarray gipch
iscale init 0.80 ;tempo scale
icnt init 0
istart init 0
idur init 0
ipch init 0
until icnt > 20 do  ;until duration of the array
 idur = gidurs[icnt%i1]
 ipch = gipch[icnt%i1]
 schedule 1,(istart + 0.45) * iscale,idur * iscale, ipch, 100, 0 ;melody inst
istart = istart + idur
icnt += 1 
od

	;Melody (swing) instrument
	instr 1
ifrq	=	p4
kv1	line	p5, p3, p6 ;filter Q
asig	STKMoog cpspch(ifrq), 1, 2, kv1, 4, 120, 11, 40, 1, 1, 128, 120
asig	=	asig * .2
aenv transeg 1, p4*.85, -15, 0
	outs asig * aenv, asig * aenv
	endin

	instr 2 ;metronome pulse
kphfreq line 1.25, p3, 1.20 ;try different control envelopes
kphase phasor kphfreq
klps lpsholdp  kphase, 0, p3, 1000, p3*0.75, 0
a1	buzz klps, 1500, 2, 2
    outs a1 * .0005, a1 * .0005
    endin

</CsInstruments>
<CsScore>
i2 0 10
</CsScore>
</CsoundSynthesizer>
