;Example7.csd
;scoreless swing
;using arrays and schedule
;includes melody and harmony

<CsoundSynthesizer>
<CsOptions> 
csound -s -d -+rtaudio=ALSA -odevaudio -b1024 -B16384  
</CsOptions>
<CsInstruments>

sr	=	44100
kr	=	4410
ksmps	=	10
nchnls	=	2
0dbfs = 1

;global var as percent
giaug init 1.3
gidim init 0.7

;global arrays
gipch[] fillarray 7.05, 8.02, 7.10, 8.00, 7.08, 7.07, 7.08, 7.10, 7.11, 8.02, 8.01, 8.00, 7.10, 7.09, 7.07, 7.09, 7.10, 8.00, 8.01

gidurs[] fillarray (.5 * gidim), (.5 * giaug), (.5 * gidim), (.5 * giaug), (.5 * gidim), (.5 * giaug), (.5 * gidim), (.5 * giaug), 3.35, (.5 * giaug), (.5 * gidim), (.5 * giaug), (.5 * gidim), (.5 * giaug), 1.0, (.5 * gidim), (.5 * giaug), 2.0, 2.0

;gidurs[] fillarray 0.35, 0.65, 0.35, 0.65, 0.35, 0.65, 0.35, 0.65, 2.35, 0.65, 0.35, 0.65, 0.35, 0.65, 1.0, 0.35, 0.65, 2.0, 2.0 

gkchord[] fillarray 7.10, 8.02, 8.05, 8.07,
                    7.08, 8.00, 8.03, 8.05, 
                    7.07, 7.11, 8.02, 8.04,
                    7.07, 7.11, 8.02, 8.04, 
                    7.10, 8.00, 8.04, 8.07,
                    7.09, 8.00, 8.03, 8.05,
                    7.10, 8.02, 8.05, 7.10,
                    7.09, 8.01, 8.03, 8.05

i1 lenarray gipch
iscale init 0.425 ;tempo scale
icnt init 0
istart init 0
idur init 0
ipch init 0
until icnt > 18 do  ;until duration of the array
 ;istart = gistart[icnt%i1]
 idur = gidurs[icnt%i1]
 ipch = gipch[icnt%i1]
 schedule 1,istart * iscale,idur * iscale, ipch, 100, 0 ;melody inst
 schedule 2.1, 0.15 ,18  ;this one plays inst 2 for the duration of 18 ;harmony inst
istart = istart + idur
icnt += 1 
od

;Melody (swing) instrument
	instr 1
ifrq	=	p4
kv1	line	p5, p3, p6				;filter Q
asig	STKMoog cpspch(ifrq), 1, 2,kv1, 4, 120, 11, 40, 1, 1, 128, 120
asig	=	asig * .1
	 outs asig, asig
	endin

	;Chords event trigger instrument 3
	instr 2
iscale init 0.425 ;tempo scale (match mel inst 1)
idur = 2.0 * iscale
kcnt init 0
i1 lenarray gkchord
;printf "****array length is: %d\n", 1, i1
if metro(1/idur) == 1 then
 event "i",3,0,idur, gkchord[kcnt], 75, 0, 20
 event "i",3,0,idur, gkchord[kcnt+1], 75, 0, 20
 event "i",3,0,idur, gkchord[kcnt+2], 75, 0, 20
 event "i",3,0,idur, gkchord[kcnt+3], 75, 0, 20
kcnt = (kcnt == i1 ? 0 : kcnt+4) ;count by 4
;printk2 kcnt
endif
	endin
;----------------
	;Harmony (chords
	instr 3
ifrq	=	p4
kv1	line	p5, p3, p6	;(FM) Modulator Index One
kv3	=	p7
asig	STKWurley cpspch(p4), 0.01, 2,kv1, 4, 10, 11, kv3, 1, 30, 128, 75
	 outs asig, asig
	endin

</CsInstruments>
</CsoundSynthesizer>
